#ifndef _UENUM_H
#define _UENUM_H

///////////////////////////////////////////////////////////
// Helper class to enumerate files and folders via UFSD
//
///////////////////////////////////////////////////////////
class CUfsdEnum : public CUFSD
{
  t_FileInfo    m_FileInfo;  // Temporal structure ( to save stack in recursive function EnumDir )
  bool          m_bSkipError;
  bool          m_bRecursive;

public:

  CUfsdEnum( IN CMemoryManager*  Mm,
             IN bool bSkipError,
             IN bool bRecursive )
    : CUFSD( Mm )
    , m_bSkipError( bSkipError )
    , m_bRecursive( bRecursive )
  {}

  ~CUfsdEnum(){}

  // This function enumerates files/directories in Dir
  unsigned EnumDir(
      IN CDir* Dir
      );

  // This function is called for each enumerated file/directory
  virtual unsigned ProcessObject(
      IN CFSObject*         Fso,
      IN const t_FileInfo&  FileInfo
      ) = 0;
};


#endif // _UENUM_H
